package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesEquipmentProductionResultService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.MesAutoLineInterfaceDetailModel;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.MesAutoLineInterfaceModel;
import cn.estsh.i3plus.ext.mes.pcn.pojo.util.MesPcnExtConstWords;
import cn.estsh.i3plus.mes.pcn.serviceimpl.fsm.IShippingDispatchService;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.platform.common.util.MesPcnConstWords;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.MesPcnEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesConfig;
import cn.estsh.i3plus.pojo.mes.bean.MesEquipmentProductionResult;
import cn.estsh.i3plus.pojo.mes.bean.MesEquipmentProductionResultDetail;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import cn.estsh.i3plus.pojo.mes.repository.MesConfigRepository;
import cn.estsh.i3plus.pojo.mes.repository.MesEquipmentProductionResultDetailRepository;
import cn.estsh.i3plus.pojo.mes.repository.MesEquipmentProductionResultRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

import java.util.List;

@Service
public class MesEquipmentProductionResultServiceImpl implements IMesEquipmentProductionResultService {
    public static final Logger log = LoggerFactory.getLogger(MesEquipmentProductionResultServiceImpl.class);

    @Autowired
    private IShippingDispatchService shippingDispatchService;
    @Autowired
    private MesConfigRepository configRao;
    @Autowired
    private MesEquipmentProductionResultRepository resultRDao;
    @Autowired
    private MesEquipmentProductionResultDetailRepository resultDetailRDao;

    @Override
    public void doCreateEquipmentProductionResult(MesAutoLineInterfaceModel info) {
        String organizeCode = "";
        DdlPackBean packBean = DdlPackBean.getDdlPackBean();
        DdlPreparedPack.getStringEqualPack(MesPcnExtConstWords.CHANG_SHU_AUTO_LINE_INTERFACE,"cfgCode",packBean);
        List<MesConfig> configList = configRao.findByHqlWhere(packBean);
        for (MesConfig mesConfig : configList) {
            if (mesConfig.getCfgKey().equals(MesPcnExtConstWords.CHANG_SHU_ORGANIZE_CODE)){
                organizeCode = mesConfig.getCfgValue();
            }
        }
        if (StringUtils.isEmpty(organizeCode)) {
            log.error("没有配置表mes_config,cfg_code为CHANG_SHU_AUTO_LINE_INTERFACE,key为CHANG_SHU_ORGANIZE_CODE没有配置");
            return;
        }

        MesEquipmentProductionResult result = new MesEquipmentProductionResult();
        result.setOrganizeCode(organizeCode);
        result.setWorkCenterCode(info.getWorkCenterCode());
        result.setWorkCellCode(info.getWorkCellCode());
        result.setProductSn(info.getProductSn());
        result.setQty(info.getQty());
        result.setResult(info.getResult());
        ConvertBean.serviceModelInitialize(result, "webservices");
        resultRDao.insert(result);

        if (!CollectionUtils.isEmpty(info.getDetails())) {
            for (MesAutoLineInterfaceDetailModel detailModel : info.getDetails()) {
                MesEquipmentProductionResultDetail detail = new MesEquipmentProductionResultDetail();
                detail.setOrganizeCode(organizeCode);
                detail.setResultId(result.getId());
                detail.setBarCode(detailModel.getBarCode());
                detail.setWorkCellCode(detailModel.getWorkCellCode());
                detail.setType(detailModel.getType());
                detail.setParamName(detailModel.getParamName());
                detail.setParamValue(detailModel.getParamValue());
                ConvertBean.serviceModelInitialize(detail, "webservices");
                resultDetailRDao.insert(detail);
            }
        }

//        StationRequestBean reqBean = new StationRequestBean(organizeCode, info.getWorkCenterCode(), info.getWorkCellCode(), "webservices");
//        reqBean.setBusiType(MesPcnEnumUtil.ACTOR_RECEIVE_STRATEGY.WS_CMD_DO_SCAN.getCode());
//        reqBean.setInterfaceType(MesPcnConstWords.SHIPPING);
//        reqBean.setClientInfo("");
//        reqBean.setIsWs(false);
//        shippingDispatchService.sendScanQueueNextExec(reqBean);
    }
}
