package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.step;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesProductionDispatchContextStepService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesEquipVariableCollectContext;
import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesProductionPsInContext;
import cn.estsh.i3plus.mes.pcn.serviceimpl.fsm.BaseStepService;
import cn.estsh.i3plus.platform.common.tool.TimeTool;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import cn.estsh.i3plus.pojo.mes.model.StationResultBean;
import cn.estsh.i3plus.pojo.mes.model.StepResult;
import cn.estsh.i3plus.pojo.mes.repository.MesEquipmentProductionResultRepository;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description : 自动化线接口生成加工结果完成
 * @Author : jason.niu
 **/
@Slf4j
@Service("mesAutoLineHandleCompleteStepService")
public class MesAutoLineHandleCompleteStepService extends BaseStepService {
    @Autowired
    private IMesProductionDispatchContextStepService productionDispatchContextStepService;
    @Autowired
    private MesEquipmentProductionResultRepository equipmentProductionResultRDao;

    @Override
    public StepResult execute(StationRequestBean reqBean) {

        StationResultBean resultBean = new StationResultBean();
        final String organizeCode = reqBean.getOrganizeCode();

        StepResult stepResult = StepResult.getSuccessComplete();
        //获取进料主条码数据信息
        List<MesProductionPsInContext> productionPsInContextList = productionDispatchContextStepService.getProductionPsInContext(reqBean);

        if (!CollectionUtils.isEmpty(productionPsInContextList)) {
            List<String> productSnList = new ArrayList<>();
            for (MesProductionPsInContext context : productionPsInContextList) {
                productSnList.add(context.getProductSn());
            }

            DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(organizeCode);
            DdlPreparedPack.getInPackList(productSnList, "productSn", ddlPackBean);
            equipmentProductionResultRDao.updateByProperties(new String[]{"modifyUser", "modifyDatetime", "generateRecord"},
                    new Object[]{reqBean.getUserInfo(), TimeTool.getNowTime(true),
                            CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue()}, ddlPackBean);
        }

        return stepSuccessCompleteAndSendMsgReturn(reqBean, resultBean.writeDbLog(), stepResult, "处理自动化线生产结果成功!");
    }
}
